Subject: bug#73620: libtool-2.5.3 broken on CentOS and Alma Linux

From: Bruno Haible <[email-masked]>
Date: Fri, 04 Oct 2024 01:00:09 +0200

Hi,

In GNU gettext's CI, two months ago, I started using libtool-2.5.1.
All fine on all platforms.

This week, I upgraded to libtool-2.5.3, and what I see is that most
unit tests fail on CentOS 7 and Alma Linux 9, i.e. both RHEL compatible
distros.

How to reproduce:
0. Use a machine with Alma Linux 9 (e.g. from AlmaLinux-9.0-x86_64-dvd.iso
   with VirtualBox or QEMU).
1. Download the tarball generated by the CI:
  $ wget https://alpha.gnu.org/gnu/gettext/gettext-2024-10-02.tar.gz
2. Unpack
  $ tar xfz gettext-2024-10-02.tar.gz
3. Build
  $ mkdir build-64
  $ cd build-64
  $ ../configure
  $ make
  $ make check

Apparently the wrapper executables for most programs in gettext-tools/src/
are dysfunctional.

When I try to run one, in particular:
  $ cd gettext-tools/src
  $ ./xgettext --help
  /home/bruno/gettext-2024-10-02/build-64/gettext-tools/src/.libs/lt-xgettext: error while loading shared libraries: libtextstyle.so.0: cannot open shared object file: No such file or directory

But libtextstyle.so.0 exists in the build tree, at
  /home/bruno/gettext-2024-10-02/build-64/libtextstyle/lib/.libs/libtextstyle.so.0

I'm attaching the xgettext wrapper scripts
  - from Ubuntu 22.04 (where it works)
  - from Alma Linux 9 (where it is broken)

You can see that the main difference is that on Alma Linux, a relink command is
being used. This raises two questions:

  1) Why is the relink command not working? (Recall that omitting the relink
     is just an optimization.)

  2) Why is the "omit the relink" optimization not activated?

Bruno